
#name MST_LOADER_IMPL, MST_LOADER

#autotype		on

program			-> decl *;

decl			: void
decl			-> "class" $word {CL} parent {ECP} "{" (class_decl *) {DCP} "}"; <<< CommitClass >>>

parent			: void
parent			-> ;
parent			-> ":" $word;											<<< Parent >>>

class_decl		: void
class_decl		-> "|" ($word *) "|";									<<< Variables >>>
class_decl		-> ("^" "|" | "^|") ($word *) "|";						<<< ClassVariables >>>

// method declaration
// print on: display
class_decl		-> method "{" statements "}";							<<< construct >>>

method			-> $word | keyword_m;									<<< Method >>>
method			-> "^" $word | "^" keyword_m;							<<< ClassMethod >>>

keyword_m		: KEYWORD_METHOD
keyword_m		-> $keyword $word +;									<<< KeyMethod >>>

statements		-> [local (st % ".") ["."]];

st				: void
st				-> expr;												<<< StExec >>>
st				-> "^" expr;											<<< StReturn >>>

local			: void
local			-> ;
local			-> "|" ($word *) "|";									<<< Local >>>

left			$keyword;
left			$binop;
left			$word;

expr			: EXPR
expr			-> $word "=" expr; shift($word, $binop) reduce($keyword) <<< Assign >>>

expr			-> expr message_list; shift(";")

message_list	-> {DCS} message;
message_list	-> message_list ";" {ECS} message;

message			-> key_list; shift($keyword)							<<< Message >>>
message			-> $binop expr;											<<< BinOp >>>
message			-> $word;												<<< Message >>>

/*
expr			-> expr key_list; shift($keyword)						<<< Message >>>
expr			-> expr $binop expr;									<<< BinOp >>>
expr			-> expr $word; 											<<< Message >>>
*/

expr			-> $word;												<<< Select >>>
expr			-> "self";												<<< Self >>>
expr			-> "super";												<<< Super >>>

expr			-> $int;												<<< Integer >>>
expr			-> $float;												<<< Float >>>
expr			-> $literal;											<<< Literal >>>
expr			-> $char;												<<< Char >>>

expr			-> "(" expr ")";
expr			-> "[" block_args statements "]";						<<< BlockExpr >>>

block_args		: void
block_args		-> ;													<<< Block >>>
block_args		-> (":" $word +) "|";									<<< Block >>>

key_list		: KEY_LIST
key_list		-> $keyword expr;										<<< KeyList >>>
key_list		-> key_list $keyword expr;								<<< KeyList >>>

$word			= {\S^\y\d}{\S^\y}*
$binop			= {\y^"\{\}.\[\]}[{\y^"\{\}.\[\]}]
$keyword		= {\S^\y\d}{\S^\y}*:
$int			= [\+|-]\d+
$float			= [\+|-]\d*.\d+[(e|E)[\+|-]\d+]
$literal		= "({^\"\\}|\\{^})*"
$char			= '({^\\}|\\{^})'

$word,
$binop,
$keyword,
$int,
$float,
$char,
$literal 		: string

skip			= \s

cbegin			= /{*}
cend			= {*}/
cline			= //

preset default {
	+all
}

preset class {
	+all -"class"
}

msg {
	MST1000		= "Unexpected token '{name}'";
	MST1001		= "Class with name '{name}' already exists";
	MST1002		= "Unknown parent class '{name}'";
	MST1003		= "Unknown variable '{name}'";
}
