
/*************************************************************************/
/* LOADER.CPP                                                   E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#include "stdafx.h"

using namespace ecg;
using namespace std;

/*************************************************************************/
/* LOADER::LOADER()                                                      */
/*                                                                       */
/*************************************************************************/
LOADER::LOADER(void)
{
	// STATE COUNT
    compilerAuto.SetStateCount(STATE_COUNT);

	// NONTERM TABLE
    compilerAuto.AddNontermAction(  0, TOKEN_NT_PROGRAM,           2);
    compilerAuto.AddNontermAction(  0, TOKEN_NT_PROGRAM_1,         TOKEN_EOF);
    compilerAuto.AddNontermAction(  3, TOKEN_NT_WORL,              6);
    compilerAuto.AddNontermAction(  7, TOKEN_NT_WORL,              8);
    compilerAuto.AddNontermAction(  9, TOKEN_NT_DECLARATION_LIST,  10);
    compilerAuto.AddNontermAction( 10, TOKEN_NT_WORL,              12);
    compilerAuto.AddNontermAction( 10, TOKEN_NT_DECLARATION,       13);
    compilerAuto.AddNontermAction( 10, TOKEN_NT_TERM_LIST,         14);
    compilerAuto.AddNontermAction( 10, TOKEN_NT_TERM,              15);
    compilerAuto.AddNontermAction( 10, TOKEN_NT_RULE,              16);
    compilerAuto.AddNontermAction( 14, TOKEN_NT_CODE_BLOCK_NE,     21);
    compilerAuto.AddNontermAction( 17, TOKEN_NT_CODE_BLOCK_NE,     26);
    compilerAuto.AddNontermAction( 17, TOKEN_NT_RULE_OR_LIST,      27);
    compilerAuto.AddNontermAction( 17, TOKEN_NT_RULE_ITEM,         28);
    compilerAuto.AddNontermAction( 17, TOKEN_NT_ITEM_LIST,         29);
    compilerAuto.AddNontermAction( 17, TOKEN_NT_ITEM,              30);
    compilerAuto.AddNontermAction( 19, TOKEN_NT_WORL,              12);
    compilerAuto.AddNontermAction( 19, TOKEN_NT_TERM,              32);
    compilerAuto.AddNontermAction( 20, TOKEN_NT_WORL,              33);
    compilerAuto.AddNontermAction( 22, TOKEN_NT_PREFER,            35);
    compilerAuto.AddNontermAction( 25, TOKEN_NT_CODE_BLOCK_NE,     26);
    compilerAuto.AddNontermAction( 25, TOKEN_NT_RULE,              37);
    compilerAuto.AddNontermAction( 25, TOKEN_NT_RULE_OR_LIST,      38);
    compilerAuto.AddNontermAction( 25, TOKEN_NT_RULE_ITEM,         28);
    compilerAuto.AddNontermAction( 25, TOKEN_NT_ITEM_LIST,         29);
    compilerAuto.AddNontermAction( 25, TOKEN_NT_ITEM,              30);
    compilerAuto.AddNontermAction( 29, TOKEN_NT_CODE_BLOCK_NE,     26);
    compilerAuto.AddNontermAction( 29, TOKEN_NT_ITEM,              42);
    compilerAuto.AddNontermAction( 33, TOKEN_NT_PARAMS_NE,         45);
    compilerAuto.AddNontermAction( 34, TOKEN_NT_PARAMS_NE,         46);
    compilerAuto.AddNontermAction( 34, TOKEN_NT_PARAMS,            47);
    compilerAuto.AddNontermAction( 35, TOKEN_NT_CODE_BLOCK_NE,     48);
    compilerAuto.AddNontermAction( 35, TOKEN_NT_CODE_BLOCK,        49);
    compilerAuto.AddNontermAction( 39, TOKEN_NT_CODE_BLOCK_NE,     26);
    compilerAuto.AddNontermAction( 39, TOKEN_NT_RULE_ITEM,         52);
    compilerAuto.AddNontermAction( 39, TOKEN_NT_ITEM_LIST,         29);
    compilerAuto.AddNontermAction( 39, TOKEN_NT_ITEM,              30);
    compilerAuto.AddNontermAction( 40, TOKEN_NT_CODE_BLOCK_NE,     26);
    compilerAuto.AddNontermAction( 40, TOKEN_NT_ITEM_LIST,         53);
    compilerAuto.AddNontermAction( 40, TOKEN_NT_ITEM,              30);
    compilerAuto.AddNontermAction( 43, TOKEN_NT_WORL,              54);
    compilerAuto.AddNontermAction( 43, TOKEN_NT_PARAM_LIST,        55);
    compilerAuto.AddNontermAction( 53, TOKEN_NT_CODE_BLOCK_NE,     26);
    compilerAuto.AddNontermAction( 53, TOKEN_NT_ITEM,              42);
    compilerAuto.AddNontermAction( 57, TOKEN_NT_WORL,              59);

	// ACTION TABLE
    compilerAuto.AddTermShiftAction (  0, TOKEN_T_NAME,             1);
    compilerAuto.AddTermShiftAction (  1, TOKEN_T_LB,               3);
    compilerAuto.AddTermReduceAction(  2, TOKEN_EOF,                1,   17);
    compilerAuto.AddTermShiftAction (  3, TOKEN_T_WORD,             4,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction (  3, TOKEN_T_LITERAL,          5,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction(  4, TOKEN_T_OR,               1,    0);
    compilerAuto.AddTermReduceAction(  4, TOKEN_T_COMMA,            1,    0);
    compilerAuto.AddTermReduceAction(  4, TOKEN_T_LB,               1,    0);
    compilerAuto.AddTermReduceAction(  4, TOKEN_T_RB,               1,    0);
    compilerAuto.AddTermReduceAction(  4, TOKEN_T_BEGIN,            1,    0);
    compilerAuto.AddTermReduceAction(  4, TOKEN_T_END,              1,    0);
    compilerAuto.AddTermReduceAction(  5, TOKEN_T_OR,               1,    0);
    compilerAuto.AddTermReduceAction(  5, TOKEN_T_COMMA,            1,    0);
    compilerAuto.AddTermReduceAction(  5, TOKEN_T_LB,               1,    0);
    compilerAuto.AddTermReduceAction(  5, TOKEN_T_RB,               1,    0);
    compilerAuto.AddTermReduceAction(  5, TOKEN_T_BEGIN,            1,    0);
    compilerAuto.AddTermReduceAction(  5, TOKEN_T_END,              1,    0);
    compilerAuto.AddTermShiftAction (  6, TOKEN_T_COMMA,            7);
    compilerAuto.AddTermShiftAction (  7, TOKEN_T_WORD,             4,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction (  7, TOKEN_T_LITERAL,          5,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction (  8, TOKEN_T_RB,               9);
    compilerAuto.AddTermReduceAction(  9, TOKEN_EOF,                0,    1);
    compilerAuto.AddTermReduceAction(  9, TOKEN_T_WORD,             0,    1);
    compilerAuto.AddTermReduceAction(  9, TOKEN_T_LITERAL,          0,    1);
    compilerAuto.AddTermReduceAction( 10, TOKEN_EOF,                7,    2,       LOADER_IMPL::SetName);
    compilerAuto.AddTermShiftAction ( 10, TOKEN_T_WORD,            11,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 10, TOKEN_T_LITERAL,          5,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 11, TOKEN_T_OR,               1,    0);
    compilerAuto.AddTermShiftAction ( 11, TOKEN_T_IS,              17);
    compilerAuto.AddTermReduceAction( 11, TOKEN_T_BEGIN,            1,    0);
    compilerAuto.AddTermShiftAction ( 11, TOKEN_T_EQU,             18);
    compilerAuto.AddTermReduceAction( 12, TOKEN_T_OR,               1,   10);
    compilerAuto.AddTermReduceAction( 12, TOKEN_T_BEGIN,            1,   10);
    compilerAuto.AddTermReduceAction( 13, TOKEN_EOF,                2,    1);
    compilerAuto.AddTermReduceAction( 13, TOKEN_T_WORD,             2,    1);
    compilerAuto.AddTermReduceAction( 13, TOKEN_T_LITERAL,          2,    1);
    compilerAuto.AddTermShiftAction ( 14, TOKEN_T_OR,              19);
    compilerAuto.AddTermShiftAction ( 14, TOKEN_T_BEGIN,           20);
    compilerAuto.AddTermReduceAction( 15, TOKEN_T_OR,               1,    4,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 15, TOKEN_T_BEGIN,            1,    4,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermShiftAction ( 16, TOKEN_T_DCOMMA,          22);
    compilerAuto.AddTermShiftAction ( 17, TOKEN_T_WORD,            23,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 17, TOKEN_T_LITERAL,         24,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 17, TOKEN_T_OR,               0,   14,       LOADER_IMPL::EmptyRuleItem);
    compilerAuto.AddTermReduceAction( 17, TOKEN_T_DCOMMA,           0,   14,       LOADER_IMPL::EmptyRuleItem);
    compilerAuto.AddTermShiftAction ( 17, TOKEN_T_LB,              25);
    compilerAuto.AddTermReduceAction( 17, TOKEN_T_RB,               0,   14,       LOADER_IMPL::EmptyRuleItem);
    compilerAuto.AddTermShiftAction ( 17, TOKEN_T_BEGIN,           20);
    compilerAuto.AddTermShiftAction ( 18, TOKEN_T_LITERAL,         31,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 19, TOKEN_T_WORD,             4,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 19, TOKEN_T_LITERAL,          5,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 20, TOKEN_T_WORD,             4,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 20, TOKEN_T_LITERAL,          5,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 21, TOKEN_EOF,                2,    3,       LOADER_IMPL::DeclTerminals);
    compilerAuto.AddTermReduceAction( 21, TOKEN_T_WORD,             2,    3,       LOADER_IMPL::DeclTerminals);
    compilerAuto.AddTermReduceAction( 21, TOKEN_T_LITERAL,          2,    3,       LOADER_IMPL::DeclTerminals);
    compilerAuto.AddTermReduceAction( 22, TOKEN_EOF,                0,   12,       LOADER_IMPL::PreferNone);
    compilerAuto.AddTermReduceAction( 22, TOKEN_T_WORD,             0,   12,       LOADER_IMPL::PreferNone);
    compilerAuto.AddTermReduceAction( 22, TOKEN_T_LITERAL,          0,   12,       LOADER_IMPL::PreferNone);
    compilerAuto.AddTermReduceAction( 22, TOKEN_T_BEGIN,            0,   12,       LOADER_IMPL::PreferNone);
    compilerAuto.AddTermShiftAction ( 22, TOKEN_T_PREFER_SHIFT,    34);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_WORD,             1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_LITERAL,          1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_OR,               1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_DCOMMA,           1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_MULTI,            1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_MANY,             1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_LB,               1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_RB,               1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 23, TOKEN_T_BEGIN,            1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_WORD,             1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_LITERAL,          1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_OR,               1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_DCOMMA,           1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_MULTI,            1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_MANY,             1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_LB,               1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_RB,               1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermReduceAction( 24, TOKEN_T_BEGIN,            1,   16,       LOADER_IMPL::AddTerminalItem);
    compilerAuto.AddTermShiftAction ( 25, TOKEN_T_WORD,            36,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 25, TOKEN_T_LITERAL,         24,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 25, TOKEN_T_OR,               0,   14,       LOADER_IMPL::EmptyRuleItem);
    compilerAuto.AddTermShiftAction ( 25, TOKEN_T_LB,              25);
    compilerAuto.AddTermReduceAction( 25, TOKEN_T_RB,               0,   14,       LOADER_IMPL::EmptyRuleItem);
    compilerAuto.AddTermShiftAction ( 25, TOKEN_T_BEGIN,           20);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_WORD,             1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_LITERAL,          1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_OR,               1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_DCOMMA,           1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_MULTI,            1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_MANY,             1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_LB,               1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_RB,               1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermReduceAction( 26, TOKEN_T_BEGIN,            1,   16,       LOADER_IMPL::AddCodeBlockItem);
    compilerAuto.AddTermShiftAction ( 27, TOKEN_T_OR,              39);
    compilerAuto.AddTermReduceAction( 27, TOKEN_T_DCOMMA,           3,   11,       LOADER_IMPL::CreateRule);
    compilerAuto.AddTermReduceAction( 27, TOKEN_T_RB,               3,   11,       LOADER_IMPL::CreateRule);
    compilerAuto.AddTermReduceAction( 28, TOKEN_T_OR,               1,   13,       LOADER_IMPL::CreateRuleOrList);
    compilerAuto.AddTermReduceAction( 28, TOKEN_T_DCOMMA,           1,   13,       LOADER_IMPL::CreateRuleOrList);
    compilerAuto.AddTermReduceAction( 28, TOKEN_T_RB,               1,   13,       LOADER_IMPL::CreateRuleOrList);
    compilerAuto.AddTermShiftAction ( 29, TOKEN_T_WORD,            23,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 29, TOKEN_T_LITERAL,         24,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 29, TOKEN_T_OR,               1,   14,       LOADER_IMPL::SimpleRuleItem);
    compilerAuto.AddTermReduceAction( 29, TOKEN_T_DCOMMA,           1,   14,       LOADER_IMPL::SimpleRuleItem);
    compilerAuto.AddTermShiftAction ( 29, TOKEN_T_MULTI,           40);
    compilerAuto.AddTermShiftAction ( 29, TOKEN_T_MANY,            41);
    compilerAuto.AddTermShiftAction ( 29, TOKEN_T_LB,              25);
    compilerAuto.AddTermReduceAction( 29, TOKEN_T_RB,               1,   14,       LOADER_IMPL::SimpleRuleItem);
    compilerAuto.AddTermShiftAction ( 29, TOKEN_T_BEGIN,           20);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_WORD,             1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_LITERAL,          1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_OR,               1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_DCOMMA,           1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_MULTI,            1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_MANY,             1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_LB,               1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_RB,               1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 30, TOKEN_T_BEGIN,            1,   15,       LOADER_IMPL::CreateItemList);
    compilerAuto.AddTermReduceAction( 31, TOKEN_EOF,                3,    3,       LOADER_IMPL::SetAlias);
    compilerAuto.AddTermReduceAction( 31, TOKEN_T_WORD,             3,    3,       LOADER_IMPL::SetAlias);
    compilerAuto.AddTermReduceAction( 31, TOKEN_T_LITERAL,          3,    3,       LOADER_IMPL::SetAlias);
    compilerAuto.AddTermReduceAction( 32, TOKEN_T_OR,               3,    4,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 32, TOKEN_T_BEGIN,            3,    4,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermShiftAction ( 33, TOKEN_T_LB,              43);
    compilerAuto.AddTermShiftAction ( 33, TOKEN_T_END,             44);
    compilerAuto.AddTermReduceAction( 34, TOKEN_EOF,                0,    7,       LOADER_IMPL::EmptyParams);
    compilerAuto.AddTermReduceAction( 34, TOKEN_T_WORD,             0,    7,       LOADER_IMPL::EmptyParams);
    compilerAuto.AddTermReduceAction( 34, TOKEN_T_LITERAL,          0,    7,       LOADER_IMPL::EmptyParams);
    compilerAuto.AddTermShiftAction ( 34, TOKEN_T_LB,              43);
    compilerAuto.AddTermReduceAction( 34, TOKEN_T_BEGIN,            0,    7,       LOADER_IMPL::EmptyParams);
    compilerAuto.AddTermReduceAction( 35, TOKEN_EOF,                0,    9,       LOADER_IMPL::EmptyCodeBlock);
    compilerAuto.AddTermReduceAction( 35, TOKEN_T_WORD,             0,    9,       LOADER_IMPL::EmptyCodeBlock);
    compilerAuto.AddTermReduceAction( 35, TOKEN_T_LITERAL,          0,    9,       LOADER_IMPL::EmptyCodeBlock);
    compilerAuto.AddTermShiftAction ( 35, TOKEN_T_BEGIN,           20);
    compilerAuto.AddTermReduceAction( 36, TOKEN_T_WORD,             1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 36, TOKEN_T_LITERAL,          1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 36, TOKEN_T_OR,               1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermShiftAction ( 36, TOKEN_T_IS,              17);
    compilerAuto.AddTermReduceAction( 36, TOKEN_T_MULTI,            1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 36, TOKEN_T_MANY,             1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 36, TOKEN_T_LB,               1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 36, TOKEN_T_RB,               1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermReduceAction( 36, TOKEN_T_BEGIN,            1,   16,       LOADER_IMPL::AddTerminalWordItem);
    compilerAuto.AddTermShiftAction ( 37, TOKEN_T_RB,              50);
    compilerAuto.AddTermShiftAction ( 38, TOKEN_T_OR,              39);
    compilerAuto.AddTermShiftAction ( 38, TOKEN_T_RB,              51);
    compilerAuto.AddTermShiftAction ( 39, TOKEN_T_WORD,            23,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 39, TOKEN_T_LITERAL,         24,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 39, TOKEN_T_OR,               0,   14,       LOADER_IMPL::EmptyRuleItem);
    compilerAuto.AddTermReduceAction( 39, TOKEN_T_DCOMMA,           0,   14,       LOADER_IMPL::EmptyRuleItem);
    compilerAuto.AddTermShiftAction ( 39, TOKEN_T_LB,              25);
    compilerAuto.AddTermReduceAction( 39, TOKEN_T_RB,               0,   14,       LOADER_IMPL::EmptyRuleItem);
    compilerAuto.AddTermShiftAction ( 39, TOKEN_T_BEGIN,           20);
    compilerAuto.AddTermShiftAction ( 40, TOKEN_T_WORD,            23,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 40, TOKEN_T_LITERAL,         24,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 40, TOKEN_T_OR,               2,   14,       LOADER_IMPL::PeriodicRuleItem);
    compilerAuto.AddTermReduceAction( 40, TOKEN_T_DCOMMA,           2,   14,       LOADER_IMPL::PeriodicRuleItem);
    compilerAuto.AddTermShiftAction ( 40, TOKEN_T_LB,              25);
    compilerAuto.AddTermReduceAction( 40, TOKEN_T_RB,               2,   14,       LOADER_IMPL::PeriodicRuleItem);
    compilerAuto.AddTermShiftAction ( 40, TOKEN_T_BEGIN,           20);
    compilerAuto.AddTermReduceAction( 41, TOKEN_T_OR,               2,   14,       LOADER_IMPL::NonEmptyPeriodicRuleItem);
    compilerAuto.AddTermReduceAction( 41, TOKEN_T_DCOMMA,           2,   14,       LOADER_IMPL::NonEmptyPeriodicRuleItem);
    compilerAuto.AddTermReduceAction( 41, TOKEN_T_RB,               2,   14,       LOADER_IMPL::NonEmptyPeriodicRuleItem);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_WORD,             2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_LITERAL,          2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_OR,               2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_DCOMMA,           2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_MULTI,            2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_MANY,             2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_LB,               2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_RB,               2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermReduceAction( 42, TOKEN_T_BEGIN,            2,   15,       LOADER_IMPL::AppendItemList);
    compilerAuto.AddTermShiftAction ( 43, TOKEN_T_WORD,             4,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 43, TOKEN_T_LITERAL,          5,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 44, TOKEN_EOF,                3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_WORD,             3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_LITERAL,          3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_OR,               3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_DCOMMA,           3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_MULTI,            3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_MANY,             3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_LB,               3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_RB,               3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermReduceAction( 44, TOKEN_T_BEGIN,            3,    5,       LOADER_IMPL::SimpleCodeBlock);
    compilerAuto.AddTermShiftAction ( 45, TOKEN_T_END,             56);
    compilerAuto.AddTermReduceAction( 46, TOKEN_EOF,                1,    7);
    compilerAuto.AddTermReduceAction( 46, TOKEN_T_WORD,             1,    7);
    compilerAuto.AddTermReduceAction( 46, TOKEN_T_LITERAL,          1,    7);
    compilerAuto.AddTermReduceAction( 46, TOKEN_T_BEGIN,            1,    7);
    compilerAuto.AddTermReduceAction( 47, TOKEN_EOF,                2,   12,       LOADER_IMPL::PreferShift);
    compilerAuto.AddTermReduceAction( 47, TOKEN_T_WORD,             2,   12,       LOADER_IMPL::PreferShift);
    compilerAuto.AddTermReduceAction( 47, TOKEN_T_LITERAL,          2,   12,       LOADER_IMPL::PreferShift);
    compilerAuto.AddTermReduceAction( 47, TOKEN_T_BEGIN,            2,   12,       LOADER_IMPL::PreferShift);
    compilerAuto.AddTermReduceAction( 48, TOKEN_EOF,                1,    9);
    compilerAuto.AddTermReduceAction( 48, TOKEN_T_WORD,             1,    9);
    compilerAuto.AddTermReduceAction( 48, TOKEN_T_LITERAL,          1,    9);
    compilerAuto.AddTermReduceAction( 49, TOKEN_EOF,                4,    3,       LOADER_IMPL::AddRules);
    compilerAuto.AddTermReduceAction( 49, TOKEN_T_WORD,             4,    3,       LOADER_IMPL::AddRules);
    compilerAuto.AddTermReduceAction( 49, TOKEN_T_LITERAL,          4,    3,       LOADER_IMPL::AddRules);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_WORD,             3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_LITERAL,          3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_OR,               3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_DCOMMA,           3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_MULTI,            3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_MANY,             3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_LB,               3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_RB,               3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 50, TOKEN_T_BEGIN,            3,   16,       LOADER_IMPL::AddBracketsItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_WORD,             3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_LITERAL,          3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_OR,               3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_DCOMMA,           3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_MULTI,            3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_MANY,             3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_LB,               3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_RB,               3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 51, TOKEN_T_BEGIN,            3,   16,       LOADER_IMPL::AddBracketsOrItem);
    compilerAuto.AddTermReduceAction( 52, TOKEN_T_OR,               3,   13,       LOADER_IMPL::AppendRuleOrList);
    compilerAuto.AddTermReduceAction( 52, TOKEN_T_DCOMMA,           3,   13,       LOADER_IMPL::AppendRuleOrList);
    compilerAuto.AddTermReduceAction( 52, TOKEN_T_RB,               3,   13,       LOADER_IMPL::AppendRuleOrList);
    compilerAuto.AddTermShiftAction ( 53, TOKEN_T_WORD,            23,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 53, TOKEN_T_LITERAL,         24,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 53, TOKEN_T_OR,               3,   14,       LOADER_IMPL::DelimitedPeriodicRuleItem);
    compilerAuto.AddTermReduceAction( 53, TOKEN_T_DCOMMA,           3,   14,       LOADER_IMPL::DelimitedPeriodicRuleItem);
    compilerAuto.AddTermShiftAction ( 53, TOKEN_T_LB,              25);
    compilerAuto.AddTermReduceAction( 53, TOKEN_T_RB,               3,   14,       LOADER_IMPL::DelimitedPeriodicRuleItem);
    compilerAuto.AddTermShiftAction ( 53, TOKEN_T_BEGIN,           20);
    compilerAuto.AddTermReduceAction( 54, TOKEN_T_COMMA,            1,    8,       LOADER_IMPL::FirstParam);
    compilerAuto.AddTermReduceAction( 54, TOKEN_T_RB,               1,    8,       LOADER_IMPL::FirstParam);
    compilerAuto.AddTermShiftAction ( 55, TOKEN_T_COMMA,           57);
    compilerAuto.AddTermShiftAction ( 55, TOKEN_T_RB,              58);
    compilerAuto.AddTermReduceAction( 56, TOKEN_EOF,                4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_WORD,             4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_LITERAL,          4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_OR,               4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_DCOMMA,           4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_MULTI,            4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_MANY,             4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_LB,               4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_RB,               4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermReduceAction( 56, TOKEN_T_BEGIN,            4,    5,       LOADER_IMPL::ParametrizedCodeBlock);
    compilerAuto.AddTermShiftAction ( 57, TOKEN_T_WORD,             4,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermShiftAction ( 57, TOKEN_T_LITERAL,          5,             LOADER_IMPL::WordLiteral);
    compilerAuto.AddTermReduceAction( 58, TOKEN_EOF,                3,    6);
    compilerAuto.AddTermReduceAction( 58, TOKEN_T_WORD,             3,    6);
    compilerAuto.AddTermReduceAction( 58, TOKEN_T_LITERAL,          3,    6);
    compilerAuto.AddTermReduceAction( 58, TOKEN_T_BEGIN,            3,    6);
    compilerAuto.AddTermReduceAction( 58, TOKEN_T_END,              3,    6);
    compilerAuto.AddTermReduceAction( 59, TOKEN_T_COMMA,            3,    8,       LOADER_IMPL::AddParam);
    compilerAuto.AddTermReduceAction( 59, TOKEN_T_RB,               3,    8,       LOADER_IMPL::AddParam);
}

/*************************************************************************/
/* LOADER::Compile()                                                     */
/*                                                                       */
/*************************************************************************/
bool LOADER::Compile(void)
{
	return compilerAuto.Compile(static_cast<LOADER_IMPL &> (*this));
}
