
#name LEX

SLASH		= "\\"

program		: void

program		-> e;									<<< SetFinalRegexp >>>

$char		= {^}

preset default {
	+$char +"{" +"}" +"\\"
	"(" ")" "[" "]" "*" "+" "|"
}

preset set {
	+$char  +"{" +"}" +"\\"
	"^" "-"
}

preset slash {
	$char_sl = {^}
}

left "|";
left concat $char "\\" "{";
left "*" "+";
left "(" "[";

$char		: string
$char_sl	: string
e			: [REGEXP]

"{"			<<< SetPreset >>>
"}"			<<< DefPreset >>>
SLASH		<<< SlashPreset >>>
$char_sl	<<< RestorePreset >>>

e			-> $char;								<<< SimpleRegexp >>>
e			-> SLASH $char_sl;						<<< FixedSetRegexp >>>
e			-> set2;								<<< SetRegexp >>>

set2, set, s : [CHARS]
set2		-> "{" set "}";
set2		-> "{" set "^" set "}";					<<< NegativeSet >>>
set			-> ;
set			-> set s;								<<< CharsUnion >>>
s			-> $char;								<<< SingleChar >>>
s			-> $char "-" $char;						<<< RangeChars >>>
s			-> SLASH $char_sl;						<<< FixedCharSet >>>
s			-> set2;

e			-> e e;				prior(concat)		<<< ConcatRegexp >>>
e			-> e "*";								<<< AnyRegexp >>>
e			-> e "+";								<<< ManyRegexp >>>
e			-> e "|" e;								<<< OrRegexp >>>
e			-> "[" e "]";							<<< YesNotRegexp >>>
e			-> "(" e ")";

msg {
	LEX1000		= "Terminal '{name}' already has regular expression";
	LEX1001		= "Regexp conflict with '{name}' and '{name2}'";
	LEX1002		= "Failed to calculate presets";
	LEX1003		= "Unexpected end of the regular expression after '\\' symbol";
	LEX1004		= "Closing bracket '}' not found";
	LEX1005		= "Unexpected closing bracket '}'";
	LEX1006		= "Unexpected symbol '{name}'";
	LEX1007		= "Unknown preset '{name}' in '{name2}' preset declaration";
	LEX1008		= "Recursion with '{name}' in '{name2}' preset declaration";
	LEX1009		= "A conflict found in the preset '{name}'";
	LEX1010		= "Comment's begin-block should be specified (use 'cbegin')";
	LEX1011		= "Comment's end-block should be specified (use 'cend')";
	LEX1012 	= "Bad escape-symbol in set '\\{name}'";
}
