
#include "stdafx.h"
#include "ecg_os.h"

#include <windows.h>

#pragma comment(lib, "winmm")

namespace ecg {

/************************************************************************/
/* ecg::OpenFile
/*
/************************************************************************/
HANDLE FileOpen(const char * name, FILE_OPEN type)
{
	DWORD access;
	DWORD share = 0;
	DWORD create;
	if (type == OF_READ) {
		access = GENERIC_READ;
		share  = FILE_SHARE_READ;
		create = OPEN_EXISTING;
	} else {
		access = GENERIC_WRITE;
		if (type == OF_WRITE) {
			create = CREATE_NEW;
		} else {
			assert(type = FO_APPEND);
			create = OPEN_ALWAYS;
		}
	}

	::HANDLE file = CreateFile(name, access, share, NULL, create, 0, NULL);

	if (file == INVALID_HANDLE_VALUE) {
		return NULL;
	}

	return reinterpret_cast<ecg::HANDLE> (file);
}

/************************************************************************/
/* ecg::FileRead
/*
/************************************************************************/
int FileRead(HANDLE file, void * dst, int length)
{
	DWORD written;
	if (!ReadFile(file, dst, length, &written, NULL)) {
		return 0;
	}

	return (int)written;
}

/************************************************************************/
/* ecg::FileSeek
/*
/************************************************************************/
int FileSeek(HANDLE file, int position, FILE_SEEK type)
{
	int method;
	if (type == FS_BEGIN) {
		method = FILE_BEGIN;
	} else if (type == FS_CURRENT) {
		method = FILE_CURRENT;
	} else {
		assert(type == FS_END);
		method = FILE_END;
	}

	return (int)SetFilePointer(file, position, NULL, method);
}

/************************************************************************/
/* ecg::FileClose
/*
/************************************************************************/
void FileClose(HANDLE file)
{
	CloseHandle(file);
}

/************************************************************************/
/* ecg::Timer
/*
/************************************************************************/
int Timer(void)
{
	return (int)timeGetTime();
}

/************************************************************************/
/* ecg::Timer2
/*
/************************************************************************/
int64 Timer2(void)
{
	LARGE_INTEGER num;
	QueryPerformanceCounter(&num);
	return num.QuadPart;
}

/************************************************************************/
/* ecg::Timer2Freq
/*
/************************************************************************/
int64 Timer2Freq(void)
{
	LARGE_INTEGER num;
	QueryPerformanceFrequency(&num);
	return num.QuadPart;
}

/************************************************************************/
/* ecg::FolderCreate
/*
/************************************************************************/
void FolderCreate(const char * path)
{
	int length = (int)strlen(path);
	std::string cur;
	for (;;) {
		bool found = false;
		for (int i=0; i<length; ++i) {
			if (path[i] == '/' || path[i] == '\\') {
				cur = std::string(path, path + i);
				found = true;
				break;
			}
		}
		if (!found) {
			cur = path;
		}

		CreateDirectory(cur.c_str(), NULL);

		if (!found) {
			return ;
		}
	}
}

}