
/************************************************************************/
/* ecg::STR_ID::c_str
/*
/************************************************************************/
const char * STR_ID::c_str(void) const
{
	if (id == -1) {
		return NULL;
	}

	assert(id >= 0 && id < (int)STR_POOL::Get()->pool.size());
	return STR_POOL::Get()->pool[id].c_str();
}

/************************************************************************/
/* ecg::STR_ID::str
/*
/************************************************************************/
const std::string & STR_ID::str(void) const
{
	if (id == -1) {
		assert(!"Unknown string");
		static std::string dummy;
		return dummy;
	}

	assert(id >= 0 && id < (int)STR_POOL::Get()->pool.size());
	return STR_POOL::Get()->pool[id];
}

/************************************************************************/
/* ecg::STR_POOL::Add
/*
/************************************************************************/
STR_ID STR_POOL::Add(const std::string & str)
{
	STR_ID newId;
	newId.id = (int)pool.size();
	pool.push_back(str);

	std::set<STR_ID>::const_iterator iter = poolId.find(newId);

	if (iter == poolId.end()) {
		poolId.insert(newId);
		return newId;
	}

	pool.pop_back();
	return *iter;
}

/************************************************************************/
/* ecg::STR_POOL::Clear
/*
/************************************************************************/
void STR_POOL::Clear(void)
{
	pool.clear();
	poolId.clear();
}