
/*************************************************************************/
/* LEX_IMPL.CPP                                                      E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#include "stdafx.h"
#include "ecg_generator.h"

using namespace ecg;
using namespace std;

/*************************************************************************/
/* LEX_IMPL::actionTable
/* 
/*************************************************************************/
const LEX_IMPL::ACTION LEX_IMPL::actionTable[STATE_COUNT][TERM_COUNT] = {
	{ { AUTO_T::SHIFT, 1 }, { AUTO_T::SHIFT, 2 }, { AUTO_T::SHIFT, 3 }, {}, { AUTO_T::SHIFT, 4 }, {}, { AUTO_T::SHIFT, 5 }, {}, {}, {}, {}, {}, {}, {}, },
	{ {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::SHIFT, 9 }, },
	{ { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, {}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, { AUTO_T::REDUCE, 1}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 12}, { AUTO_T::REDUCE, 12}, { AUTO_T::REDUCE, 12}, { AUTO_T::REDUCE, 12}, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::REDUCE, 12}, {}, {}, },
	{ { AUTO_T::SHIFT, 1 }, { AUTO_T::SHIFT, 2 }, { AUTO_T::SHIFT, 3 }, {}, { AUTO_T::SHIFT, 4 }, {}, { AUTO_T::SHIFT, 5 }, {}, {}, {}, {}, {}, {}, {}, },
	{ { AUTO_T::SHIFT, 1 }, { AUTO_T::SHIFT, 2 }, { AUTO_T::SHIFT, 3 }, {}, { AUTO_T::SHIFT, 4 }, {}, { AUTO_T::SHIFT, 5 }, {}, {}, {}, {}, {}, {}, {}, },
	{ {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, },
	{ { AUTO_T::SHIFT, 1 }, { AUTO_T::SHIFT, 2 }, { AUTO_T::SHIFT, 3 }, {}, { AUTO_T::SHIFT, 4 }, {}, { AUTO_T::SHIFT, 5 }, {}, { AUTO_T::SHIFT, 13 }, { AUTO_T::SHIFT, 14 }, { AUTO_T::SHIFT, 15 }, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 3}, {}, { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 3}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, {}, { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, { AUTO_T::REDUCE, 2}, {}, {}, {}, },
	{ { AUTO_T::SHIFT, 17 }, { AUTO_T::SHIFT, 18 }, { AUTO_T::SHIFT, 3 }, { AUTO_T::SHIFT, 19 }, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::SHIFT, 20 }, {}, {}, },
	{ { AUTO_T::SHIFT, 1 }, { AUTO_T::SHIFT, 2 }, { AUTO_T::SHIFT, 3 }, {}, { AUTO_T::SHIFT, 4 }, { AUTO_T::SHIFT, 23 }, { AUTO_T::SHIFT, 5 }, {}, { AUTO_T::SHIFT, 13 }, { AUTO_T::SHIFT, 14 }, { AUTO_T::SHIFT, 15 }, {}, {}, {}, },
	{ { AUTO_T::SHIFT, 1 }, { AUTO_T::SHIFT, 2 }, { AUTO_T::SHIFT, 3 }, {}, { AUTO_T::SHIFT, 4 }, {}, { AUTO_T::SHIFT, 5 }, { AUTO_T::SHIFT, 24 }, { AUTO_T::SHIFT, 13 }, { AUTO_T::SHIFT, 14 }, { AUTO_T::SHIFT, 15 }, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, {}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 5}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, {}, { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, { AUTO_T::REDUCE, 6}, {}, {}, {}, },
	{ { AUTO_T::SHIFT, 1 }, { AUTO_T::SHIFT, 2 }, { AUTO_T::SHIFT, 3 }, {}, { AUTO_T::SHIFT, 4 }, {}, { AUTO_T::SHIFT, 5 }, {}, {}, {}, {}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 4}, { AUTO_T::REDUCE, 4}, { AUTO_T::REDUCE, 4}, {}, { AUTO_T::SHIFT, 4 }, { AUTO_T::REDUCE, 4}, { AUTO_T::SHIFT, 5 }, { AUTO_T::REDUCE, 4}, { AUTO_T::SHIFT, 13 }, { AUTO_T::SHIFT, 14 }, { AUTO_T::REDUCE, 4}, {}, {}, {}, },
	{ {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::SHIFT, 26 }, },
	{ { AUTO_T::REDUCE, 14}, { AUTO_T::REDUCE, 14}, { AUTO_T::REDUCE, 14}, { AUTO_T::REDUCE, 14}, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::REDUCE, 14}, { AUTO_T::SHIFT, 27 }, {}, },
	{ { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, { AUTO_T::REDUCE, 10}, {}, {}, },
	{ { AUTO_T::REDUCE, 12}, { AUTO_T::REDUCE, 12}, { AUTO_T::REDUCE, 12}, { AUTO_T::REDUCE, 12}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 17}, { AUTO_T::REDUCE, 17}, { AUTO_T::REDUCE, 17}, { AUTO_T::REDUCE, 17}, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::REDUCE, 17}, {}, {}, },
	{ { AUTO_T::REDUCE, 13}, { AUTO_T::REDUCE, 13}, { AUTO_T::REDUCE, 13}, { AUTO_T::REDUCE, 13}, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::REDUCE, 13}, {}, {}, },
	{ { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 9}, {}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 9}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 8}, {}, { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 8}, {}, {}, {}, },
	{ { AUTO_T::SHIFT, 1 }, { AUTO_T::SHIFT, 2 }, { AUTO_T::SHIFT, 3 }, {}, { AUTO_T::SHIFT, 4 }, { AUTO_T::REDUCE, 7}, { AUTO_T::SHIFT, 5 }, { AUTO_T::REDUCE, 7}, { AUTO_T::SHIFT, 13 }, { AUTO_T::SHIFT, 14 }, { AUTO_T::REDUCE, 7}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 16}, { AUTO_T::REDUCE, 16}, { AUTO_T::REDUCE, 16}, { AUTO_T::REDUCE, 16}, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::REDUCE, 16}, {}, {}, },
	{ {}, { AUTO_T::SHIFT, 29 }, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, },
	{ { AUTO_T::SHIFT, 17 }, { AUTO_T::SHIFT, 18 }, { AUTO_T::SHIFT, 3 }, { AUTO_T::SHIFT, 30 }, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, },
	{ { AUTO_T::REDUCE, 15}, { AUTO_T::REDUCE, 15}, { AUTO_T::REDUCE, 15}, { AUTO_T::REDUCE, 15}, {}, {}, {}, {}, {}, {}, {}, { AUTO_T::REDUCE, 15}, {}, {}, },
	{ { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, { AUTO_T::REDUCE, 11}, {}, {}, },
};

/*************************************************************************/
/* LEX_IMPL::actionTableEof
/* 
/*************************************************************************/
const LEX_IMPL::ACTION LEX_IMPL::actionTableEof[STATE_COUNT] = {
	{}, {}, { AUTO_T::REDUCE, 1}, {}, {}, {}, { AUTO_T::REDUCE, 18}, { AUTO_T::REDUCE, 0}, { AUTO_T::REDUCE, 3}, { AUTO_T::REDUCE, 2}, {}, {}, {}, { AUTO_T::REDUCE, 5}, { AUTO_T::REDUCE, 6}, {}, { AUTO_T::REDUCE, 4}, {}, {}, { AUTO_T::REDUCE, 10}, {}, {}, {}, { AUTO_T::REDUCE, 9}, { AUTO_T::REDUCE, 8}, { AUTO_T::REDUCE, 7}, {}, {}, {}, {}, { AUTO_T::REDUCE, 11}, };

/*************************************************************************/
/* LEX_IMPL::actionTableError
/* 
/*************************************************************************/
const LEX_IMPL::ACTION LEX_IMPL::actionTableError[STATE_COUNT] = {
	{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, };

/*************************************************************************/
/* LEX_IMPL::productionTable
/* 
/*************************************************************************/
const int LEX_IMPL::productionTable[STATE_COUNT][NONTERM_COUNT] = {
	{ 6, 7, 8, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, 10, -1, -1, },
	{ -1, 11, 8, -1, -1, -1, },
	{ -1, 12, 8, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, 16, 8, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, 21, -1, 22, -1, },
	{ -1, 16, 8, -1, -1, -1, },
	{ -1, 16, 8, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, 25, 8, -1, -1, -1, },
	{ -1, 16, 8, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, 28, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, 16, 8, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, 21, -1, 22, -1, },
	{ -1, -1, -1, -1, -1, -1, },
	{ -1, -1, -1, -1, -1, -1, },
};

/*************************************************************************/
/* LEX_IMPL::procTableProduction
/* 
/*************************************************************************/
const LEX_IMPL::PRODUCTION LEX_IMPL::procTableProduction[RULE_COUNT] = {
	{ &LEX::SetFinalRegexp_Impl0, 1, 0 },
	{ &LEX::SimpleRegexp_Impl0, 1, 1 },
	{ &LEX::FixedSetRegexp_Impl0, 2, 1 },
	{ &LEX::SetRegexp_Impl0, 1, 1 },
	{ &LEX::ConcatRegexp_Impl0, 2, 1 },
	{ &LEX::AnyRegexp_Impl0, 2, 1 },
	{ &LEX::ManyRegexp_Impl0, 2, 1 },
	{ &LEX::OrRegexp_Impl0, 3, 1 },
	{ &LEX::YesNotRegexp_Impl0, 3, 1 },
	{ NULL, 3, 1 },
	{ NULL, 3, 2 },
	{ &LEX::NegativeSet_Impl0, 5, 2 },
	{ &LEX::intConstructor_Impl0, 0, 3 },
	{ &LEX::CharsUnion_Impl0, 2, 3 },
	{ &LEX::SingleChar_Impl0, 1, 4 },
	{ &LEX::RangeChars_Impl0, 3, 4 },
	{ &LEX::FixedCharSet_Impl0, 2, 4 },
	{ NULL, 1, 4 },
	{ NULL, 1, 5 },
};

/*************************************************************************/
/* LEX_IMPL::procTableTerm
/* 
/*************************************************************************/
const LEX_IMPL::ACTION_PROC LEX_IMPL::procTableTerm[TERM_COUNT] = {
	&LEX::SlashPreset,
	&LEX::intPushString,
	&LEX::SetPreset,
	&LEX::DefPreset,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&LEX::RestorePreset_Impl0,
};

/*************************************************************************/
/* LEX_IMPL::procTableNonterm
/* 
/*************************************************************************/
const LEX_IMPL::ACTION_PROC LEX_IMPL::procTableNonterm[NONTERM_COUNT] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
};

/*************************************************************************/
/* LEX_IMPL::LEX_IMPL()                                                  */
/*                                                                       */
/*************************************************************************/
LEX_IMPL::LEX_IMPL(void)
	: vstack(sizeof(VALUE_T))
{
	compilerAuto.actionTable		= &actionTable;
	compilerAuto.actionTableEof		= actionTableEof;
	compilerAuto.actionTableError	= actionTableError;
	compilerAuto.productionTable	= &productionTable;
	compilerAuto.procTableProduction = procTableProduction;
	compilerAuto.procTableTerm		= procTableTerm;
	compilerAuto.procTableNonterm	= procTableNonterm;
}

/*************************************************************************/
/* Impl()                                                                */
/*                                                                       */
/*************************************************************************/
LEX & LEX_IMPL::Impl(void)
{
	return * static_cast<IMPL_T *> (this);
}

/*************************************************************************/
/* intPushString()                                                       */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::intPushString(void)
{
	sstack.push(Impl().TokenValue());
}

/*************************************************************************/
/* intPushEmptyString()                                                  */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::intPushEmptyString(void)
{
	sstack.push(std::string());
}

/*************************************************************************/
/* intCreateStringArray()                                                */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::intCreateStringArray(void)
{
	pstack.push(new std::vector<std::string>());
	pstack.top<std::vector<std::string> >()->push_back(sstack.top());
	sstack.pop();
}

/*************************************************************************/
/* intAppendStringArray()                                                */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::intAppendStringArray(void)
{
	pstack.top<std::vector<std::string> >()->push_back(sstack.top());
	sstack.pop();
}

/*************************************************************************/
/* intCreatePtrArray()                                                   */
/*                                                                       */
/*************************************************************************/
template <class T> void LEX_IMPL::intCreatePtrArray(void)
{
	P<T> a = pstack.pop<T>();
	pstack.push(new std::vector<P<T> >());
	pstack.top<std::vector<P<T> > >()->push_back(a);
}

/*************************************************************************/
/* intAppendPtrArray()                                                   */
/*                                                                       */
/*************************************************************************/
template <class T> void LEX_IMPL::intAppendPtrArray(void)
{
	P<T> a = pstack.pop<T>();
	pstack.top<std::vector<P<T> > >()->push_back(a);
}

template <class T>
struct VALUE_TYPE_HELPER;

/*************************************************************************/
/* intCreateValArray()                                                   */
/*                                                                       */
/*************************************************************************/
template <class T> void LEX_IMPL::intCreateValArray(void)
{
	T a = VALUE_TYPE_HELPER<T>::get(vstack.top<VALUE_T>());
	vstack.pop();
	pstack.push(new std::vector<T>());
	pstack.top<std::vector<T> >()->push_back(a);
}

/*************************************************************************/
/* intAppendValArray()                                                   */
/*                                                                       */
/*************************************************************************/
template <class T> void LEX_IMPL::intAppendValArray(void)
{
	T a = VALUE_TYPE_HELPER<T>::get(vstack.top<VALUE_T>());
	vstack.pop();
	pstack.top<std::vector<T> >()->push_back(a);
}

/*************************************************************************/
/* LEX_IMPL::AnyRegexp_Impl0()                                           */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::AnyRegexp_Impl0(void)
{
	P<IMPL_T::REGEXP > a = pstack.pop<IMPL_T::REGEXP >();
	P<IMPL_T::REGEXP > result;
	Impl().AnyRegexp(a, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::CharsUnion_Impl0()                                          */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::CharsUnion_Impl0(void)
{
	P<IMPL_T::CHARS > b = pstack.pop<IMPL_T::CHARS >();
	P<IMPL_T::CHARS > a = pstack.pop<IMPL_T::CHARS >();
	P<IMPL_T::CHARS > result;
	Impl().CharsUnion(a, b, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::ConcatRegexp_Impl0()                                        */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::ConcatRegexp_Impl0(void)
{
	P<IMPL_T::REGEXP > b = pstack.pop<IMPL_T::REGEXP >();
	P<IMPL_T::REGEXP > a = pstack.pop<IMPL_T::REGEXP >();
	P<IMPL_T::REGEXP > result;
	Impl().ConcatRegexp(a, b, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::FixedCharSet_Impl0()                                        */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::FixedCharSet_Impl0(void)
{
	std::string a = sstack.top();
	sstack.pop();
	P<IMPL_T::CHARS > result;
	Impl().FixedCharSet(a, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::FixedSetRegexp_Impl0()                                      */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::FixedSetRegexp_Impl0(void)
{
	std::string a = sstack.top();
	sstack.pop();
	P<IMPL_T::REGEXP > result;
	Impl().FixedSetRegexp(a, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::ManyRegexp_Impl0()                                          */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::ManyRegexp_Impl0(void)
{
	P<IMPL_T::REGEXP > a = pstack.pop<IMPL_T::REGEXP >();
	P<IMPL_T::REGEXP > result;
	Impl().ManyRegexp(a, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::NegativeSet_Impl0()                                         */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::NegativeSet_Impl0(void)
{
	P<IMPL_T::CHARS > b = pstack.pop<IMPL_T::CHARS >();
	P<IMPL_T::CHARS > a = pstack.pop<IMPL_T::CHARS >();
	P<IMPL_T::CHARS > result;
	Impl().NegativeSet(a, b, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::OrRegexp_Impl0()                                            */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::OrRegexp_Impl0(void)
{
	P<IMPL_T::REGEXP > b = pstack.pop<IMPL_T::REGEXP >();
	P<IMPL_T::REGEXP > a = pstack.pop<IMPL_T::REGEXP >();
	P<IMPL_T::REGEXP > result;
	Impl().OrRegexp(a, b, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::RangeChars_Impl0()                                          */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::RangeChars_Impl0(void)
{
	std::string b = sstack.top();
	sstack.pop();
	std::string a = sstack.top();
	sstack.pop();
	P<IMPL_T::CHARS > result;
	Impl().RangeChars(a, b, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::RestorePreset_Impl0()                                       */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::RestorePreset_Impl0(void)
{
	std::string result;
	Impl().RestorePreset(result);
	sstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::SetFinalRegexp_Impl0()                                      */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::SetFinalRegexp_Impl0(void)
{
	P<IMPL_T::REGEXP > a = pstack.pop<IMPL_T::REGEXP >();
	Impl().SetFinalRegexp(a);
}

/*************************************************************************/
/* LEX_IMPL::SetRegexp_Impl0()                                           */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::SetRegexp_Impl0(void)
{
	P<IMPL_T::CHARS > a = pstack.pop<IMPL_T::CHARS >();
	P<IMPL_T::REGEXP > result;
	Impl().SetRegexp(a, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::SimpleRegexp_Impl0()                                        */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::SimpleRegexp_Impl0(void)
{
	std::string a = sstack.top();
	sstack.pop();
	P<IMPL_T::REGEXP > result;
	Impl().SimpleRegexp(a, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::SingleChar_Impl0()                                          */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::SingleChar_Impl0(void)
{
	std::string a = sstack.top();
	sstack.pop();
	P<IMPL_T::CHARS > result;
	Impl().SingleChar(a, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::YesNotRegexp_Impl0()                                        */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::YesNotRegexp_Impl0(void)
{
	P<IMPL_T::REGEXP > a = pstack.pop<IMPL_T::REGEXP >();
	P<IMPL_T::REGEXP > result;
	Impl().YesNotRegexp(a, result);
	assert(Impl().compilerState.is(CST_ERROR_MASK) || result != NULL);
	pstack.push(result);
}

/*************************************************************************/
/* LEX_IMPL::intConstructor_Impl0()                                      */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::intConstructor_Impl0(void)
{
	pstack.push(new IMPL_T::CHARS());
}


/*************************************************************************/
/* LEX_IMPL::Compile()                                                   */
/*                                                                       */
/*************************************************************************/
void LEX_IMPL::Compile(void)
{
	compilerAuto.Compile(static_cast<IMPL_T &> (*this));
}
