
/*************************************************************************/
/* LEX                                                               E13 */
/*                                                                       */
/* generated by ecg                                                      */
/*************************************************************************/

#ifndef LEX_LEX_H
#define LEX_LEX_H

#ifndef TOKEN_EOF
#define TOKEN_EOF		-1
#endif

#ifndef TOKEN_ERROR
#define TOKEN_ERROR		-2
#endif

namespace ecg {

class LEX_LEX {
public:
	enum TERMINALS {
		TOKEN_T_SLASH,   // '\'
		TOKEN_T_CHAR,    // '$char'
		TOKEN_T_NAME_1,  // '{'
		TOKEN_T_NAME_2,  // '}'
		TOKEN_T_NAME_3,  // '('
		TOKEN_T_NAME_4,  // ')'
		TOKEN_T_NAME_5,  // '['
		TOKEN_T_NAME_6,  // ']'
		TOKEN_T_NAME_7,  // '*'
		TOKEN_T_NAME_8,  // '+'
		TOKEN_T_NAME_9,  // '|'
		TOKEN_T_NAME_10, // '^'
		TOKEN_T_NAME_11, // '-'
		TOKEN_T_CHAR_SL, // '$char_sl'
	};

	typedef unsigned char CHAR_T;

public:
	LEX_LEX(void);

	int					Token			(void) const { return token; }
	const std::string & TokenValue		(void) const { return value; }
	int 				NextToken		(void);

	enum PRESET {
		PRESET_DEFAULT,
		PRESET_SET,
		PRESET_SLASH,
	};

	void				SetPreset		(PRESET preset);
	void				PushPreset		(PRESET preset);
	void				PopPreset		(void);
	PRESET				GetPreset		(void) const;

protected:
	virtual void		Unexpected		(char ch);
	virtual void		Unexpected		(const std::string & val = std::string()); // empty string means end of file

private:
	bool				PopChar		(CHAR_T & ch);
	void				PushChar	(CHAR_T ch);

protected:
	int					token;
	std::string			value;

private:
	// enables unget any count of chars
	std::stack<CHAR_T>	charStack;

	// preset data
	std::stack<PRESET>	presetsStack;

	static const int 	final_default[];
	static const int 	final_set[];
	static const int 	final_slash[];

	// parsing data
	const int *			final;

	static const int	table[][15];
	static const int	terminal[];
};

} // namespace ecg

#endif // LEX_LEX_H
