
/*************************************************************************/
/* MSG                                                               E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#include "stdafx.h"
#include "ecg_generator.h"

namespace ecg {

/*************************************************************************/
/* LEX_MSG::messageTable
/* 
/*************************************************************************/
const MSG_HOLDER LEX_messageTable[] = {
	{ "LEX1000", "Terminal '{name}' already has regular expression",  },
	{ "LEX1001", "Regexp conflict with '{name}' and '{name2}'",  },
	{ "LEX1002", "Failed to calculate presets",  },
	{ "LEX1003", "Unexpected end of the regular expression after '\\' symbol",  },
	{ "LEX1004", "Closing bracket '}' not found",  },
	{ "LEX1005", "Unexpected closing bracket '}'",  },
	{ "LEX1006", "Unexpected symbol '{name}'",  },
	{ "LEX1007", "Unknown preset '{name}' in '{name2}' preset declaration",  },
	{ "LEX1008", "Recursion with '{name}' in '{name2}' preset declaration",  },
	{ "LEX1009", "A conflict found in the preset '{name}'",  },
	{ "LEX1010", "Comment's begin-block should be specified (use 'cbegin')",  },
	{ "LEX1011", "Comment's end-block should be specified (use 'cend')",  },
	{ "LEX1012", "Bad escape-symbol in set '\\{name}'",  },
};

/*************************************************************************/
/* GetMessage()                                                          */
/*                                                                       */
/*************************************************************************/
const MSG_HOLDER * LEX_GetMessage(const std::string & id)
{
	int index = ecg::FindMessage(id, LEX_messageTable, 13);
	if (index == -1) {
		return NULL;
	}
	return &LEX_messageTable[index];
}

/*************************************************************************/
/* GetMessageByIndex()                                                   */
/*                                                                       */
/*************************************************************************/
const MSG_HOLDER * LEX_GetMessageByIndex(int index)
{
	return &LEX_messageTable[index];
}

} // namespace ecg
