
/*************************************************************************/
/* LOADER_IMPL.H                                                     E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#ifndef LOADER_IMPL_H
#define LOADER_IMPL_H

#ifndef TOKEN_EOF
#define TOKEN_EOF		-1
#endif

#ifndef TOKEN_ERROR
#define TOKEN_ERROR		-2
#endif

namespace ecg {

class LOADER;

/*************************************************************************/
/* class LOADER_IMPL                                                     */
/*                                                                       */
/*************************************************************************/
class LOADER_IMPL {
public:
	enum {
		STATE_COUNT		= 183,
		TERM_COUNT		= 44,
		NONTERM_COUNT	= 43,
		RULE_COUNT		= 109,
	};

	//enum TERMINALS {
	//		TOKEN_T_COMMA,				// ","
	//		TOKEN_T_LB,					// "("
	//		TOKEN_T_RB,					// ")"
	//		TOKEN_T_WORD,				// $word
	//		TOKEN_T_LITERAL,			// $literal
	//		TOKEN_T_CLINE,				// $cline
	//		TOKEN_T_CBEGIN,				// $cbegin
	//		TOKEN_T_CEND,				// $cend
	//		TOKEN_T_EOLN,				// $eoln
	//		TOKEN_T_NAME_1,				// "-"
	//		TOKEN_T_SKIP,				// "skip"
	//		TOKEN_T_NAME_2,				// "{"
	//		TOKEN_T_NAME_3,				// "}"
	//		TOKEN_T_NAME_4,				// "->"
	//		TOKEN_T_NAME_5,				// "+"
	//		TOKEN_T_NAME_6,				// "="
	//		TOKEN_T_REGEXP,				// $regexp
	//		TOKEN_T_NAME,				// $name
	//		TOKEN_T_NAME_7,				// "#name"
	//		TOKEN_T_NAME_8,				// "#start"
	//		TOKEN_T_PRESET,				// "preset"
	//		TOKEN_T_L,					// "L"
	//		TOKEN_T_NAME_9,				// "|"
	//		TOKEN_T_NAME_10,			// "<<<"
	//		TOKEN_T_NAME_11,			// ">>>"
	//		TOKEN_T_CONSTRUCT,			// "construct"
	//		TOKEN_T_NAME_12,			// ";"
	//		TOKEN_T_SHIFT,				// "shift"
	//		TOKEN_T_REDUCE,				// "reduce"
	//		TOKEN_T_PRIOR,				// "prior"
	//		TOKEN_T_EOF,				// $eof
	//		TOKEN_T_NAME_13,			// ":"
	//		TOKEN_T_NAME_14,			// "]"
	//		TOKEN_T_NAME_15,			// "*"
	//		TOKEN_T_NAME_16,			// "["
	//		TOKEN_T_NAME_17,			// "%"
	//		TOKEN_T_ERROR,				// $error
	//		TOKEN_T_LEFT,				// "left"
	//		TOKEN_T_RIGHT,				// "right"
	//		TOKEN_T_NAME_18,			// "cline"
	//		TOKEN_T_NAME_19,			// "cbegin"
	//		TOKEN_T_NAME_20,			// "cend"
	//		TOKEN_T_NAME_21,			// "#autotype"
	//		TOKEN_T_MSG,				// "msg"
	//};

	enum NONTERMINALS {
		TOKEN_NT_PROGRAM,		// program
		TOKEN_NT_WORL,			// worl
		TOKEN_NT_DECLARATION,	// declaration
		TOKEN_NT_ANONYMOUS_0,	// anonymous_0
		TOKEN_NT_PARAM,			// param
		TOKEN_NT_ANONYMOUS_1,	// anonymous_1
		TOKEN_NT_CODE_BLOCK,	// code_block
		TOKEN_NT_CODE_NAME,		// code_name
		TOKEN_NT_PARAMS_NE,		// params_ne
		TOKEN_NT_ANONYMOUS_2,	// anonymous_2
		TOKEN_NT_RULE,			// rule
		TOKEN_NT_ATTRIB_LIST,	// attrib_list
		TOKEN_NT_SHIFT_PARAMS,	// shift_params
		TOKEN_NT_SHIFT_TERM,	// shift_term
		TOKEN_NT_ANONYMOUS_3,	// anonymous_3
		TOKEN_NT_ANONYMOUS_4,	// anonymous_4
		TOKEN_NT_RULE_LIST,		// rule_list
		TOKEN_NT_TYPE,			// type
		TOKEN_NT_NT_TYPE,		// nt_type
		TOKEN_NT_RULE_ITEM,		// rule_item
		TOKEN_NT_ITEM_LIST,		// item_list
		TOKEN_NT_ITEM,			// item
		TOKEN_NT_ITEM2,			// item2
		TOKEN_NT_ANONYMOUS_5,	// anonymous_5
		TOKEN_NT_ANONYMOUS_6,	// anonymous_6
		TOKEN_NT_ANONYMOUS_7,	// anonymous_7
		TOKEN_NT_ALIAS_NAME,	// alias_name
		TOKEN_NT_REGEXP_PRIOR,	// regexp_prior
		TOKEN_NT_ANONYMOUS_8,	// anonymous_8
		TOKEN_NT_ANONYMOUS_9,	// anonymous_9
		TOKEN_NT_ANONYMOUS_10,	// anonymous_10
		TOKEN_NT_ANONYMOUS_11,	// anonymous_11
		TOKEN_NT_ANONYMOUS_12,	// anonymous_12
		TOKEN_NT_ANONYMOUS_13,	// anonymous_13
		TOKEN_NT_PR_COM,		// pr_com
		TOKEN_NT_ANONYMOUS_14,	// anonymous_14
		TOKEN_NT_ANONYMOUS_15,	// anonymous_15
		TOKEN_NT_ANONYMOUS_16,	// anonymous_16
		TOKEN_NT_ANONYMOUS_17,	// anonymous_17
		TOKEN_NT_MESSAGE,		// message
		TOKEN_NT_ANONYMOUS_18,	// anonymous_18
		TOKEN_NT_ANONYMOUS_19,	// anonymous_19
		TOKEN_NT_PROGRAM_1,		// program_1
	};

	typedef int VALUE_T;
	typedef LOADER IMPL_T;

public:
						LOADER_IMPL		(void);
	void				Compile				(void);

protected:
	void				intPushString		(void);
	void				intPushEmptyString	(void);
	void				intCreateStringArray(void);
	void				intAppendStringArray(void);

	template <class T> void intCreatePtrArray(void);
	template <class T> void intAppendPtrArray(void);
	template <class T> void intCreateValArray(void);
	template <class T> void intAppendValArray(void);

protected:
	void				CPT_Impl0		(void);
	void				CheckAliasName_Impl0		(void);
	void				CodeAttrib_Impl0		(void);
	void				CommitGrammar_Impl0		(void);
	void				CommitRuleAndItsCodeBlock_Impl0		(void);
	void				CreateBracketsItem_Impl0		(void);
	void				CreateBracketsOrItem_Impl0		(void);
	void				CreateCodeBlockItem_Impl0		(void);
	void				CreateRule_Impl0		(void);
	void				CreateTermItem_Impl0		(void);
	void				CreateWordItem_Impl0		(void);
	void				CreateWordItem_Impl1		(void);
	void				CreateYesNotItem_Impl0		(void);
	void				FNT_Impl0		(void);
	void				LexCBegin_Impl0		(void);
	void				LexCEnd_Impl0		(void);
	void				LexCLine_Impl0		(void);
	void				LexCommand_Impl0		(void);
	void				LexCommand_Impl1		(void);
	void				LexPresetRegexp_Impl0		(void);
	void				LexPresetSkip_Impl0		(void);
	void				LexPresetTerm_Impl0		(void);
	void				LexRegexp_Impl0		(void);
	void				LexSkip_Impl0		(void);
	void				LiteralToString_Impl0		(void);
	void				Message_Impl0		(void);
	void				PTND_Impl0		(void);
	void				PTNM_Impl0		(void);
	void				ParametrizedCodeBlock_Impl0		(void);
	void				PopPresetString_Impl0		(void);
	void				PriorAttrib_Impl0		(void);
	void				ProcessLiteral_Impl0		(void);
	void				PushPreset_Impl0		(void);
	void				ReduceAttrib_Impl0		(void);
	void				RegisterPriority_Impl0		(void);
	void				RegisterPriority_Impl1		(void);
	void				RegisterResultType_Impl0		(void);
	void				SetAlias_Impl0		(void);
	void				SetItemsCodeBlock_Impl0		(void);
	void				ShiftAttrib_Impl0		(void);
	void				SimpleCodeBlock_Impl0		(void);
	void				StartNonterminal_Impl0		(void);
	void				TypeArray_Impl0		(void);
	void				TypeArray_Impl1		(void);
	void				TypeArray_Impl2		(void);
	void				TypeArray_Impl3		(void);
	void				Type_Impl0		(void);
	void				Type_Impl1		(void);
	void				Type_Impl2		(void);
	void				Type_Impl3		(void);
	void				intConstructor_Impl0		(void);
	void				intConstructor_Impl1		(void);
	void				intConstructor_Impl10		(void);
	void				intConstructor_Impl11		(void);
	void				intConstructor_Impl12		(void);
	void				intConstructor_Impl13		(void);
	void				intConstructor_Impl14		(void);
	void				intConstructor_Impl2		(void);
	void				intConstructor_Impl3		(void);
	void				intConstructor_Impl4		(void);
	void				intConstructor_Impl5		(void);
	void				intConstructor_Impl6		(void);
	void				intConstructor_Impl7		(void);
	void				intConstructor_Impl8		(void);
	void				intConstructor_Impl9		(void);

protected:
	COMPILER_STATE_F	compilerState;
	PTR_STACK			pstack;
	std::stack<std::string> sstack;
	RAW_STACK			vstack;

private:
	IMPL_T &			Impl			(void);

private:
	typedef AUTO_CONFIG<STATE_COUNT, TERM_COUNT, NONTERM_COUNT, RULE_COUNT> CONFIG_T;
	typedef AUTO<IMPL_T, CONFIG_T> AUTO_T;
	friend AUTO_T;

	typedef AUTO_T::ACTION		ACTION;
	typedef AUTO_T::ACTION_PROC	ACTION_PROC;
	typedef AUTO_T::PRODUCTION	PRODUCTION;

	static const ACTION			actionTable			[STATE_COUNT][TERM_COUNT];
	static const ACTION			actionTableEof		[STATE_COUNT];
	static const ACTION			actionTableError	[STATE_COUNT];
	static const int			productionTable		[STATE_COUNT][NONTERM_COUNT];
	static const PRODUCTION		procTableProduction	[RULE_COUNT];
	static const ACTION_PROC	procTableTerm		[TERM_COUNT];
	static const ACTION_PROC	procTableNonterm	[NONTERM_COUNT];

	AUTO_T				compilerAuto;
};

} // namespace ecg

#endif // LOADER_IMPL_H

