
/*************************************************************************/
/* LEX                                                               E13 */
/*                                                                       */
/* generated by ecg                                                      */
/*************************************************************************/

#ifndef LOADER_LEX_H
#define LOADER_LEX_H

#ifndef TOKEN_EOF
#define TOKEN_EOF		-1
#endif

#ifndef TOKEN_ERROR
#define TOKEN_ERROR		-2
#endif

namespace ecg {

class LOADER_LEX {
public:
	enum TERMINALS {
		TOKEN_T_COMMA,     // ','
		TOKEN_T_LB,        // '('
		TOKEN_T_RB,        // ')'
		TOKEN_T_WORD,      // '$word'
		TOKEN_T_LITERAL,   // '$literal'
		TOKEN_T_CLINE,     // '$cline'
		TOKEN_T_CBEGIN,    // '$cbegin'
		TOKEN_T_CEND,      // '$cend'
		TOKEN_T_EOLN,      // '$eoln'
		TOKEN_T_NAME_1,    // '-'
		TOKEN_T_SKIP,      // 'skip'
		TOKEN_T_NAME_2,    // '{'
		TOKEN_T_NAME_3,    // '}'
		TOKEN_T_NAME_4,    // '->'
		TOKEN_T_NAME_5,    // '+'
		TOKEN_T_NAME_6,    // '='
		TOKEN_T_REGEXP,    // '$regexp'
		TOKEN_T_NAME,      // '$name'
		TOKEN_T_NAME_7,    // '#name'
		TOKEN_T_NAME_8,    // '#start'
		TOKEN_T_PRESET,    // 'preset'
		TOKEN_T_L,         // 'L'
		TOKEN_T_NAME_9,    // '|'
		TOKEN_T_NAME_10,   // '<<<'
		TOKEN_T_NAME_11,   // '>>>'
		TOKEN_T_CONSTRUCT, // 'construct'
		TOKEN_T_NAME_12,   // ';'
		TOKEN_T_SHIFT,     // 'shift'
		TOKEN_T_REDUCE,    // 'reduce'
		TOKEN_T_PRIOR,     // 'prior'
		TOKEN_T_EOF,       // '$eof'
		TOKEN_T_NAME_13,   // ':'
		TOKEN_T_NAME_14,   // ']'
		TOKEN_T_NAME_15,   // '*'
		TOKEN_T_NAME_16,   // '['
		TOKEN_T_NAME_17,   // '%'
		TOKEN_T_ERROR,     // '$error'
		TOKEN_T_LEFT,      // 'left'
		TOKEN_T_RIGHT,     // 'right'
		TOKEN_T_NAME_18,   // 'cline'
		TOKEN_T_NAME_19,   // 'cbegin'
		TOKEN_T_NAME_20,   // 'cend'
		TOKEN_T_NAME_21,   // '#autotype'
		TOKEN_T_MSG,       // 'msg'
	};

	enum {
		TOKEN_COMMENT_LINE			= TOKEN_T_CLINE,
		TOKEN_COMMENT_BLOCK_BEGIN	= TOKEN_T_CBEGIN,
		TOKEN_COMMENT_BLOCK_END		= TOKEN_T_CEND,
	};

	typedef unsigned char CHAR_T;

public:
	LOADER_LEX(void);

	int					Token			(void) const { return token; }
	const std::string & TokenValue		(void) const { return value; }
	int					Line			(void) const { return line + 1; }
	int 				NextToken		(void);

	enum PRESET {
		PRESET_DEFAULT,
		PRESET_COMMENT,
		PRESET_EOLN,
		PRESET_PRESET,
		PRESET_REGEXP,
		PRESET_NAME,
	};

	void				SetPreset		(PRESET preset);
	void				PushPreset		(PRESET preset);
	void				PopPreset		(void);
	PRESET				GetPreset		(void) const;

protected:
	virtual void		Unexpected		(char ch);
	virtual void		Unexpected		(const std::string & val = std::string()); // empty string means end of file

private:
	bool				PopChar		(CHAR_T & ch);
	void				PushChar	(CHAR_T ch);

protected:
	int					token;
	std::string			value;
	int					line;

private:
	// enables unget any count of chars
	std::stack<CHAR_T>	charStack;

	// preset data
	std::stack<PRESET>	presetsStack;

	static const int 	isSkip_default[];
	static const int 	final_default[];
	static const int 	productive_default[];
	static const int 	isSkip_comment[];
	static const int 	final_comment[];
	static const int 	productive_comment[];
	static const int 	isSkip_eoln[];
	static const int 	final_eoln[];
	static const int 	productive_eoln[];
	static const int 	isSkip_preset[];
	static const int 	final_preset[];
	static const int 	productive_preset[];
	static const int 	isSkip_regexp[];
	static const int 	final_regexp[];
	static const int 	productive_regexp[];
	static const int 	isSkip_name[];
	static const int 	final_name[];
	static const int 	productive_name[];

	// parsing data
	const int *			final;
	const int *			isSkip;
	const int *			productive;

	static const int	table[][48];
	static const int	terminal[];
};

} // namespace ecg

#endif // LOADER_LEX_H
