
/*************************************************************************/
/* MSG                                                               E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#include "stdafx.h"
#include "ecg_generator.h"

namespace ecg {

/*************************************************************************/
/* LOADER_MSG::messageTable
/* 
/*************************************************************************/
const MSG_HOLDER LOADER_messageTable[] = {
	{ "LDR1001", "Terminal '{name}' hasn't got regular expression",  },
	{ "LDR1002", "Failed to build lex table",  },
	{ "LDR1003", "Unexpected nonterminal '{name}' in the terminal alias block",  },
	{ "LDR1004", "Unexpected terminal '{name}' in the rule declaration",  },
	{ "LDR1005", "Unexpected nonterminal '{name}' in the terminal list",  },
	{ "LDR1006", "Code block cannot be empty because custom terminal result",  },
	{ "LDR1007", "Code block cannot be empty because nonempty argument list",  },
	{ "LDR1008", "Unknown priority '{name}'",  },
	{ "LDR1009", "Warning, replacing code block for nonterminal '{name}'",  },
	{ "LDR1010", "Overriding priority",  },
	{ "LDR1011", "Prefer shift redefinition",  },
	{ "LDR1012", "Prefer reduce redefinition",  },
	{ "LDR1013", "Result type redefinition for terminal '{name}'",  },
	{ "LDR1014", "Result type redefinition for nonterminal '{name}'",  },
	{ "LDR1015", "Unable to declare array for elements with type 'void'",  },
	{ "LDR1016", "Overriding shift attribute",  },
	{ "LDR1017", "Overriding reduce attribute",  },
	{ "LDR1018", "Overriding code attribute '{name}'",  },
	{ "LDR1019", "Overriding priority attribute '{name}'",  },
	{ "LDR1020", "Overriding terminal in priority section '{name}'",  },
	{ "LDR1021", "Overriding priority alias '{name}'",  },
	{ "LDR1022", "Bad priority value '{name}', expected 'low', 'normal' or 'high'",  },
	{ "LDR1023", "Failed to compile regular expression '{name}'",  },
	{ "LDR1024", "Redefinition of 'skip' in preset declaration",  },
	{ "LDR1025", "Failed to compile line comment regexp",  },
	{ "LDR1026", "Unexpected nonterminal '{name}' in preset declaration",  },
	{ "LDR1027", "Unexpected nonterminal in preset's local terminal declaration",  },
	{ "LDR1028", "Name '{name}' reserved and can't be used as a preset name",  },
	{ "LDR1029", "Preset '{name}' is already defined",  },
	{ "LDR1030", "Unexpected token '{name}'",  },
	{ "LDR1031", "Basic type '{name}' should be declared as a value type",  },
	{ "LDR1032", "Value types do not allow constructors",  },
	{ "LDR1033", "Message with id '{name}' is already defined",  },
};

/*************************************************************************/
/* GetMessage()                                                          */
/*                                                                       */
/*************************************************************************/
const MSG_HOLDER * LOADER_GetMessage(const std::string & id)
{
	int index = ecg::FindMessage(id, LOADER_messageTable, 33);
	if (index == -1) {
		return NULL;
	}
	return &LOADER_messageTable[index];
}

/*************************************************************************/
/* GetMessageByIndex()                                                   */
/*                                                                       */
/*************************************************************************/
const MSG_HOLDER * LOADER_GetMessageByIndex(int index)
{
	return &LOADER_messageTable[index];
}

} // namespace ecg
